Subject: bug#66041: 30.0.50; Should 'flymake-note-echo' inherit from 'compilation-info'?

From: Eli Zaretskii <[email-masked]>
Date: Mon, 18 Sep 2023 14:42:07 +0300

> From: João Távora <[email-masked]>
> Date: Mon, 18 Sep 2023 11:46:55 +0100
> Cc: Jim Porter <[email-masked]>, [email-masked]
> 
> On Mon, Sep 18, 2023, 11:44 Eli Zaretskii <[email-masked]> wrote:
> 
>  > Cc: [email-masked]
>  > From: João Távora <[email-masked]>
>  > Date: Sun, 17 Sep 2023 23:15:31 +0100
>  > 
>  > emacs -Q
>  > M-x flymake-mode RET
>  > M-: (setq flymake-show-diagnostics-at-end-of-line t) RET
>  > M-x erase-buffer RET
>  > h e l l o
>  > 
>  > The first bug I find is that the exclamation mark on the fringe is
>  > green, but it should be yellow, since, presumably a warning is
>  > more important than a note.
>  > 
>  > The second bug has to do with the placement of the cursor when
>  > two "eol overlays" are present.  The cursor shouldn't be placed
>  > in the middle of them, since they represent unreachable areas of
>  > the buffer.
> 
>  When I try the above, the cursor is at the end of "hello", and the
>  overlay with the warning is displayed after it.  So I don't think I
>  understand what you mean by "in the middle of them".
> 
> Sorry. The recipe is missing a single SPC character after the hello, so that the style warning is
> triggered.

You have there two overlays, each one with a before-string, and each
string has its first character propertized with (cursor t).  So Emacs
picks up one of the two overlay strings to place the cursor, and it
just happens to be not the one you wanted.